//
// oAux_exp.h
//
// 98 - oAux_exp.h12 - 27
//

#include <stdio.h>
#include <windows.h>
#include <GL/gl.h>

#include "oAuxKeyCodes.h"
#include "oAuxWindowTypes.h"
#include "oFooTypes.h"

/*
 * Mouse Modes
 */
#define AUX_MOUSEDOWN   16
#define AUX_MOUSEUP     32
#define AUX_MOUSELOC    64

/*
 * Buttons
 */
#define AUX_LEFTBUTTON          1
#define AUX_RIGHTBUTTON         2
#define AUX_MIDDLEBUTTON        4

#define AUX_MOUSEX              0
#define AUX_MOUSEY              1
#define AUX_MOUSESTATUS         3



/*=======================================================================*/

extern AUXRESHAPEPROC DefaultHandleReshape;

//=======================================================================*/

/*
// to store the pointer of callback functions
*/

void   APIENTRY auxReshapeFunc(AUXRESHAPEPROC Func);

//------------------------------------------------------------------

/* to make entries in >>KeyTable tkKeyTable[]<< */
void   APIENTRY auxKeyFunc(int, AUXKEYPROC);

/*-----------------------------------------------------------------*/

/*
 * to make entries in the tables 
 * struct MouseTableStruct
 *       mouseDownTable[20], mouseUpTable[20], mouseLocTable[20]
 */

void APIENTRY auxMouseFunc(int mouse, int mode, AUXMOUSEPROC Func);

void APIENTRY auxGetMouseLoc(int *x, int *y);

/*-----------------------------------------------------------------*/

/*
// to store informations about the grafik window
*/
void   APIENTRY auxInitDisplayMode(GLenum type);
void   APIENTRY auxInitPosition(int x, int y, int width, int height);

/*
 * Create and Display a grafik window with the parameter
 * defined in the functions above.
 */
GLenum APIENTRY auxInitWindow( LPCSTR title );

/*
// to store the pointer of the draw foo
// and to start the message dispatching loop
*/

void APIENTRY auxMainLoop( AUXMAINPROC Func );

/*=================================================================*/


void   APIENTRY auxSwapBuffers(void);

void   APIENTRY auxWireCube (GLdouble size);

void auxDrawBox(
			 GLdouble x0, GLdouble x1, 
			 GLdouble y0, GLdouble y1,
			 GLdouble z0, GLdouble z1, 
			 GLenum type
			 );

void auxDrawAxes();


