//
// ma_gl_pixel.c
//
// 99 - 01 - 19
//
static char version[] =
"$Id: tk_set_pixel.c,v 1.1 1999/11/21 19:55:05 Fusz Exp $";

//
// from 
// msdev/samples/sdk/demos/gengl
//

#include "oTk_intern.h"

//
// Changings
//
// 99 - 01 - 07
// MglCreateRGBPalette(hDC); removed !!
//
// 99 - 01 - 19
// The initializing of the PIXELFORMATDESCRIPTOR is done 
// single staments
//

BOOL TkSetPixelFormat(HDC hDC)
{
    static PIXELFORMATDESCRIPTOR pfd; 
 	
    int pixelformat;

    //-------------------------------------------------------

    pfd.nSize =	sizeof(PIXELFORMATDESCRIPTOR);	// size of this pfd

    pfd.nVersion = 1;				// version number

    pfd.dwFlags =
        PFD_DRAW_TO_WINDOW |		// support window
        PFD_SUPPORT_OPENGL |		// support OpenGL
        PFD_DOUBLEBUFFER;		    // double buffered

    pfd.iPixelType = PFD_TYPE_RGBA;		// RGBA type

    pfd.cColorBits = 24;				// 24-bit color depth

    pfd.cRedBits    = 0;
    pfd.cRedShift   = 0;
    pfd.cGreenBits  = 0;
    pfd.cGreenShift = 0;
    pfd.cBlueBits   = 0;
    pfd.cBlueShift  = 0; // color bits ignored

    pfd.cAlphaBits	= 0;	// no alpha buffer
    pfd.cAlphaShift	= 0;	// shift bit ignored

    pfd.cAccumBits = 0;    // no accumulation buffer
    pfd.cAccumRedBits = 0;
    pfd.cAccumGreenBits = 0;
    pfd.cAccumBlueBits = 0;
    pfd.cAccumAlphaBits = 0; // accum bits ignored

    pfd.cDepthBits = 32;				// 32-bit z-buffer	
    pfd.cStencilBits = 0;				// no stencil buffer
    pfd.cAuxBuffers = 0;				// no auxiliary buffer
    pfd.iLayerType = PFD_MAIN_PLANE;			// main layer
    pfd.bReserved = 0;				// reserved

    pfd.dwLayerMask = 0;
    pfd.dwVisibleMask = 0;
    pfd.dwDamageMask = 0;				// layer masks ignored
    
    //
    // SDK-Function
    // to obtain the DC's pixel format the is the closest
    // match to the the specified pixel format
    //
    if ( (pixelformat = ChoosePixelFormat(hDC, &pfd)) == 0 )
    {
        MessageBox(NULL, "ChoosePixelFormat failed", "Error", MB_OK);
        return FALSE;
    }

    // SDK-Fuction
    // 
    if( SetPixelFormat(hDC, pixelformat, &pfd) == FALSE )
    {
        MessageBox(NULL, "SetPixelFormat failed", "Error", MB_OK);
        return FALSE;
    }


    return TRUE;
}

