//
// tk_wnd_proc.c
//
// 98 - 12 - 23
//
static char version[] =
"$Id: tk_wnd_proc.c,v 1.1 1999/11/21 19:55:45 Fusz Exp $";

#include "oTk_intern.h"
#include "tk_wnd.h"

void ForceRedraw( HWND Window )
{
    MSG Message;
	
    if (!PeekMessage(&Message, Window, WM_PAINT, WM_PAINT, PM_NOREMOVE) )
    {
        InvalidateRect( Window, NULL, FALSE );
    }
}



LRESULT CALLBACK tkWndProc(HWND hWnd, UINT message, 
                           WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT paint;
    HDC hdc;
	
    int dummy;
	
    //------------------------------------------------------------
	
	
    dummy = 0;

    if( message == WM_MOUSEMOVE ||
        message == WM_LBUTTONDOWN ||
        message == WM_LBUTTONUP ||
        message == WM_MBUTTONDOWN ||
        message == WM_MBUTTONUP ||
        message == WM_RBUTTONDOWN ||
        message == WM_RBUTTONUP )
    {
        // printf( "Mouse message = %d", message );
        
        TkWndProcMouse( hWnd, message, wParam, lParam );
        return 0;
    }
        
    switch (message) 
    {
		
    case WM_USER:
		
        firstShowMessage("WM_USER");
		
        return(0);
		
    case WM_KEYDOWN:
		
        firstShowMessage( "WM_KEYDOWN" );
		
        TkWndProcKeys( hWnd, wParam );
		
        return 0;
		
    case WM_CHAR:
        firstShowMessage( "WM_CHAR" );
		
        TkWndProcChars( hWnd, wParam );
		
        return (0);
		
    case WM_SIZE:
        firstShowMessage("WM_SIZE");
		
        windInfo.width  = LOWORD(lParam);
        windInfo.height = HIWORD(lParam);
		
        if( TkReshapeFunc )
        {
            (*TkReshapeFunc)(windInfo.width, windInfo.height);
			
            ForceRedraw( hWnd );
        }
        return (0);
		
    case WM_MOVE:
        firstShowMessage("WM_MOVE");
		
        windInfo.x = LOWORD(lParam);
        windInfo.y = HIWORD(lParam);
		
        return (0);
		
    case WM_PAINT:
        firstShowMessage("WM_PAINT");
		
        /*
         *  Validate the region even if there are no DisplayFunc.
         *  Otherwise, USER will not stop sending WM_PAINT messages.
         */
		
        hdc = BeginPaint(tkhwnd, &paint);
		
        if (TkDisplayFunc)
        {
			
            (*TkDisplayFunc)();
        }
        else
        {
            firstShowMessage(">>TkDisplayFunc == NULL.");
        }
		
        EndPaint(tkhwnd, &paint);
		
        return (0);
		
    case WM_ACTIVATE:
        firstShowMessage("WM_ACTIVATE");
		
		
        break;
		
    case WM_DESTROY:
        PostQuitMessage(TRUE);
        return 0;
    }

    return( DefWindowProc( hWnd, message, wParam, lParam )  );
}

